'''Takes tab-delimited SNP tables from user input and merges them into one.'''

print('''Welcome to the TRAMS table merger. Please
enter the name to be used for the output file''')

while True:
    out_filename = raw_input('Name of output file: ')
    if out_filename == '': continue
    try:
        output = open(out_filename,'w')
        break
    except IOError as e:
        print 'Error trying to open \''+filename+'\': {1}'.format(e.errno, e.strerror)

print('''
Please enter the names of the input
files one by one, the output file will contain their columns in that
order. The program will keep asking for file names until you press enter
without typing anything.
''')
files = []
filenames = []

while True:
    filename = raw_input('File name: ')
    if filename == '': break
    try:
        filenames.append(filename)
        files.append(open(filename, 'rU'))
    except IOError as e:
        print 'Error trying to open \''+filename+'\': {1}'.format(e.errno, e.strerror)

print("\nMerging {} files into file '{}'".format(len(files),out_filename))

# Fetch headers and print them to output file;
headers = [File.readline()[:-1].split('\t')[1:] for File in files]
columns = [len(strains[1:]) for strains in headers]
output.write('\t'.join(['Position']+[headers[0][0]]+[a for b in headers for a in b[1:]]))
##output.write(headers[0][0])
##for strain in [a for b in headers for a in b[1:]]:
##    output.write('\t'+strain)
##    output.flush()

file_active = [True]*len(files)
snps = [row.readline()[:-1].split('\t') for row in files]

while True in file_active:
    for h in range(0,len(snps)):
        if file_active[h]:
            cur_pos = [h]
            lowest = int(snps[h][0])
            break
    i = 1

    # Determine lowest position
    while i < len(snps):
        if int(snps[i][0]) < lowest and file_active[i]:
            lowest = int(snps[i][0])
            cur_pos = [i]
        elif int(snps[i][0]) == lowest:
            cur_pos.append(i)
        i+=1

    # Check if all SNPs sharing a position have the same reference base, exit with message otherwise;
    if len(cur_pos) > 1:
        ref_base = snps[cur_pos[0]][1].lower()
        for j in cur_pos[1:]:
            if snps[j][1].lower() != ref_base:
                error = '\nError: Reference bases not the same for position %s, present in following files:' % lowest
                for k in cur_pos:
                    error += ' '+filenames[k]
                output.write(error+'.')
                output.close()
                exit(error+'.')

    # Write line to output file containing position, ref base and snps/empty cells;
    output.write('\n'+snps[cur_pos[0]][0]+'\t'+snps[cur_pos[0]][1].lower())
    for l,row in enumerate(snps):
        if l in cur_pos:
            output.write('\t'.join(['']+row[2:]))
        else:
            output.write('\t'*columns[l])

    # Read new line in files that had snp at current position;
    for m in cur_pos:
        line = files[m].readline()
        if line == '': file_active[m] = False
        else:
            snps[m] = line.split('\t')
            snps[m][-1] = snps[m][-1].rstrip()# Remove newline character at end of line;


for it in files: it.close()
output.close()
print '\ndone.'
